function Output = Analyze_EigVec(Input1, Input2, Input3, Input4, thresh)

   Ind1 = cell2mat(Input1(:,3))>=thresh;
   Ind2 = cell2mat(Input2(:,3))>=thresh;
   Ind3 = cell2mat(Input3(:,3))>=thresh;
   Ind = [Ind1, Ind2, Ind3];
   Final_Ind = all(Ind,2);
   Final_Ind2 = Final_Ind(Final_Ind == 1);
   Final_Ind3 = Final_Ind == 1;
   
   Freq1 = cell2mat(Input1(:,3));
   Freq2 = cell2mat(Input2(:,3));
   Freq3 = cell2mat(Input3(:,3));
   Freq1_thresh = Freq1(Final_Ind3);
   Freq1_thresh_sort = sort(unique(sort(Freq1_thresh, 'descend')),'descend');
   
   Stock_Ind = [];
   for i = 1:length(Freq1_thresh_sort)     
       temp1 = Freq1_thresh_sort(i);   
       for j = 1:length(Freq1) 
           target = Freq1(j);
           if temp1 == target
               Stock_Ind = [Stock_Ind; j];
           end     
       end
   end
   Stock_Name = Input4(:,1);
   Sectors = Input4(:,2);
   Stock_Name = Stock_Name(Stock_Ind,1);
   Num = length(Final_Ind2);
   
   Freq = [Freq1(Stock_Ind), Freq2(Stock_Ind), Freq3(Stock_Ind)];
   Check = find(any(Freq<thresh,2));
   
   if isempty(Check)~=1
       Freq(Check,:)=[];
       Stock_Name(Check,:)=[];
       Stock_Ind(Check,:)=[];
   end
   
   Output = {[Stock_Name, Sectors(Stock_Ind)], Freq, Stock_Ind, Num};

end