%./ input "x" is N-by-P where N is the number of observations per asset,
%./ while P is the number of assets in the pool;
%./ "h" is the sampling frequency 
%./ "option": whether use threshold
function IV = Integ_Vol(x, h, option)
  
    [rows, ~] = size(x);
    varpi = 0.48;
    alpha = 3;
    norm = (pi^(-0.5))*(2^(1/3))*(gamma(5/6));
    sigma = sqrt((norm^(-3))*(rows/(rows-2))*sum((abs(x(1:rows-2,:)).^(2/3))...
        .*(abs(x(2:rows-1,:)).^(2/3)).*(abs(x(3:rows,:)).^(2/3)))); 
    
    if option == 0 
       IV = sum((x.^2));
    else
       IV = sum((x.^2).*(abs(x)<=(ones(rows,1)*sigma*alpha*(h^(varpi)))));
    end

end