clear;clc;

load('FactorDetails_SPY_10min')

load('TotalStocks')

EigVec_Mat_PCA_EN1_Rotate = Rotate_Loadings(EigVec_Mat_PCA_EN1, Stock_Sectors);
EigVec_Mat_PCA_EN2_Rotate = Rotate_Loadings(EigVec_Mat_PCA_EN2, Stock_Sectors);
EigVec_Mat_PCA_Lasso_Rotate = Rotate_Loadings(EigVec_Mat_PCA_Lasso, Stock_Sectors);
EigVec_Mat_SPCA_EN1_Rotate = Rotate_Loadings(EigVec_Mat_SPCA_EN1, Stock_Sectors);
EigVec_Mat_SPCA_EN2_Rotate = Rotate_Loadings(EigVec_Mat_SPCA_EN2, Stock_Sectors);
EigVec_Mat_SPCA_Lasso_Rotate = Rotate_Loadings(EigVec_Mat_SPCA_Lasso, Stock_Sectors);

Output = Analyze_EigVec(Freq_SubStocks_EN1, Freq_SubStocks_EN2, Freq_SubStocks_Lasso, Stock_Sectors, 0.2);

Ind_Vec = cell2mat(Output(:,3));
   

Vec1 = [];Vec2 = [];Vec3 = [];Vec4 = [];Vec5 = [];
Vec6 = [];Vec7 = [];Vec8 = [];Vec9 = [];
Vec10 = [];Vec11 = [];Vec12 = [];Vec13 = [];Vec14 = [];
Vec15 = [];Vec16 = [];Vec17 = [];Vec18 = [];
Vec19 = [];Vec20 = [];Vec21 = [];Vec22 = [];Vec23 = [];
Vec24 = [];Vec25 = [];Vec26 = [];Vec27 = [];
for i = 1:length(Ind_Vec)
    
   Obj = cell2mat(EigVec_Mat_SPCA_EN1_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_EN1(Ind_Vec(i), 3))*380;
   Opt = 1;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec1 = [Vec1; Abs_Mean];
   Vec2 = [Vec2; RootMeanSquare];
   Vec3 = [Vec3; SampleMean];
   Vec4 = [Vec4; StdDev];
   Vec5 = [Vec5; Freq_nonzeros];
   EN1_SPCA = [Vec1, Vec2, Vec3, Vec4, Vec5];
   
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    
   Obj = cell2mat(EigVec_Mat_PCA_EN1_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_EN1(Ind_Vec(i), 3))*380;
   Opt = 0;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec6 = [Vec6; Abs_Mean];
   Vec7 = [Vec7; RootMeanSquare];
   Vec8 = [Vec8; SampleMean];
   Vec9 = [Vec9; StdDev];
   EN1_PCA = [Vec6, Vec7, Vec8, Vec9];
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Obj = cell2mat(EigVec_Mat_SPCA_EN2_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_EN2(Ind_Vec(i), 3))*380;
   Opt = 1;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec10 = [Vec10; Abs_Mean];
   Vec11 = [Vec11; RootMeanSquare];
   Vec12 = [Vec12; SampleMean];
   Vec13 = [Vec13; StdDev];
   Vec14 = [Vec14; Freq_nonzeros];
   EN2_SPCA = [Vec10, Vec11, Vec12, Vec13, Vec14];
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Obj = cell2mat(EigVec_Mat_PCA_EN2_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_EN2(Ind_Vec(i), 3))*380;
   Opt = 0;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec15 = [Vec15; Abs_Mean];
   Vec16 = [Vec16; RootMeanSquare];
   Vec17 = [Vec17; SampleMean];
   Vec18 = [Vec18; StdDev];
   EN2_PCA = [Vec15, Vec16, Vec17, Vec18];
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   Obj = cell2mat(EigVec_Mat_SPCA_Lasso_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_Lasso(Ind_Vec(i), 3))*380;
   Opt = 1;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec19 = [Vec19; Abs_Mean];
   Vec20 = [Vec20; RootMeanSquare];
   Vec21 = [Vec21; SampleMean];
   Vec22 = [Vec22; StdDev];
   Vec23 = [Vec23; Freq_nonzeros];
   Lasso_SPCA = [Vec19, Vec20, Vec21, Vec22, Vec23];
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
 
   Obj = cell2mat(EigVec_Mat_PCA_Lasso_Rotate(Ind_Vec(i), 3:382));
   NumDays = cell2mat(Freq_SubStocks_Lasso(Ind_Vec(i), 3))*380;
   Opt = 0;
   
   if Opt == 0
      Obj_adj = nonzeros(Obj);
   else
      Nonzero_Obj = nonzeros(Obj);
      Nums = length(nonzeros(Obj));
      Obj_adj = [Nonzero_Obj; zeros(floor(NumDays-Nums),1)];
   end
    
   Abs_Mean = mean(abs(Obj_adj));
   RootMeanSquare = sqrt(mean(Obj_adj.^2));
   SampleMean = mean(Obj_adj);
   StdDev = std(Obj_adj);
   if Opt == 1
      Freq_nonzeros = Nums/NumDays;
   end   
   
   Vec24 = [Vec24; Abs_Mean];
   Vec25 = [Vec25; RootMeanSquare];
   Vec26 = [Vec26; SampleMean];
   Vec27 = [Vec27; StdDev];
   Lasso_PCA = [Vec24, Vec25, Vec26, Vec27];

end

