function Output = Rotate_Loadings(Input1, Input2)

 [rows,cols] = size(Input1);
 Stocks = Input2(:,1);
 Sectors = Input2(:,2);
 Orig_Loadings = cell2mat(Input1(:,3:cols));
 
 Rotate_Loadings = [];
 for i = 1:size(Orig_Loadings,2)
     temp = Orig_Loadings(:,i);
     Sign = sign(temp);
     if sum(Sign)<=0
         temp = -temp;
     end
     Rotate_Loadings = [Rotate_Loadings, temp];
 end
 
 for j = 1:cols
     
     for s = 1:rows
         
         if j == 1
          Output{s,j} = Stocks(s);
         elseif j == 2
          Output{s,j} = Sectors(s);
         else
          Output{s,j} = Rotate_Loadings(s,j-2);
         end
         
     end
     
 end

end